<?php
/* Host Creation Tool CONFIG WIZARD */

/* Required include */
include_once(dirname(__FILE__).'/../configwizardhelper.inc.php');

/* Run the initialization function */

/* for all function names, prepend function name with the wizard's name */
/* Example: function hostcreationtool_configwizard_init() */
hostcreationtool_configwizard_init();

function hostcreationtool_configwizard_init(){
	
	/* Name / ID for config wizard */
	$name = 'hostcreationtool';
	
	/* Relevant info for wizard */
	$args = array(
		CONFIGWIZARD_NAME 			=> $name,
		CONFIGWIZARD_TYPE 			=> CONFIGWIZARD_TYPE_MONITORING,
		CONFIGWIZARD_DESCRIPTION 	=> "This wizard lets you add hosts in bulk.",
		CONFIGWIZARD_DISPLAYTITLE 	=> "Host Creation Tool",
		CONFIGWIZARD_FUNCTION 		=> "hostcreationtool_configwizard_func",
		CONFIGWIZARD_PREVIEWIMAGE 	=> "scripting.png",
		CONFIGWIZARD_VERSION 		=> "2012-08-12",
		CONFIGWIZARD_DATE 			=> '2012-08-12',
		CONFIGWIZARD_AUTHOR 		=> 'Troy Lea aka Box293',
		);
	/* Register wizard with XI */
	register_configwizard($name,$args);
	}

/* This function is automatically called by the XI wizard framework when the wizard is run */
function hostcreationtool_configwizard_func($mode = '',$inargs = null,&$outargs,&$result){

	/* Define the wizard name */
	$wizard_name = 'hostcreationtool';

	/* Initialize return code and output */
	$result = 0;
	$output = '';
	
	/* Initialize output args - pass back the same data we got -> used by XI framework, don't change */
	$outargs[CONFIGWIZARD_PASSBACK_DATA] = $inargs;

	/* The wizard will advanced depending on which mode/stage it's in. */
	/* wizard functions with the following pattern: <show stage html> -> <validate stage> -> <show next stage html> */
	/* CONFIGWIZARD_MODE_GETSTAGE1HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE1DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE2HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE2DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE3OPTS */
	/* CONFIGWIZARD_MODE_GETSTAGE3HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE3DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE4OPTS */
	/* CONFIGWIZARD_MODE_GETFINALSTAGEHTML */
	/* CONFIGWIZARD_MODE_GETOBJECTS */
	
	/* Main Wizard Stage switch */
	switch ($mode) {
		case CONFIGWIZARD_MODE_GETSTAGE1HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE2HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 
			
			/* This defines $nextstep variable, used for determining if the user did not */
			/* provide correct information when the user was on CONFIGWIZARD_MODE_GETSTAGE1HTML */
			$nextstep = htmlentities(grab_array_var($_POST,'nextstep',false),ENT_QUOTES); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_SESSION); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session[hostcreationtool] CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			$knownwizards = knownwizards();
			$knownicons = knownicons();
			
			/* Determine if this is the first wizard run */
			if ($nextstep == '') {
				/* Clear the session array to be sure it is blank */
				unset($_SESSION[$wizard_name]);
				}
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE2HTML */
			if ($back == 'Back') {
				/* User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE2HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('<br />User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
				
				/* Back was clicked when user was on CONFIGWIZARD_MODE_GETSTAGE2HTML so we need to define some variables */
				$host_type = $_SESSION[$wizard_name]['host_type'];
				$linuxdistroselect = $_SESSION[$wizard_name]['linuxdistroselect'];
				$osdistroselect = $_SESSION[$wizard_name]['osdistroselect'];
				$osdistro = $_SESSION[$wizard_name]['osdistro'];
				$userinput = $_SESSION[$wizard_name]['userinput'];
				}
			else {
				/* Fresh Wizard Run */
				/* OR */
				/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error */
				
				if (!isset($_POST['userinput'])) {
					/* Fresh Wizard Run */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />First Time The Wizard has been run <br />');
					
					/* Define the session array to hold data from different stages */
					$_SESSION[$wizard_name] = array(); 
					
					/* The following variables need to be defined to prevent coding errors */
					$host_type = '';
					$linuxdistroselect = '';
					$osdistroselect = '';
					$userinput = '';
					}
				else {
					/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error<br />'); 
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$host_type = grab_array_var($inargs,'host_type','');
					$linuxdistroselect = grab_array_var($inargs,'linuxdistroselect','');
					$osdistroselect = grab_array_var($inargs,'osdistroselect','');
					$userinput = grab_array_var($inargs,'userinput','');
					}
				}	
			
			
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE1HTML */ 
			$output = '
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>

			<div style="width: 600px;"> <!-- This div sets the width -->
			
			<div class="sectionTitle">Host Creation Tool</div>

			<p>
			<div>
				<input type="button" class="button01" onclick="toggleMe(\'para1\')" value="Overview">
			</div>
			<div id="para1" style="display:none">
				<br />
				This tool lets you create hosts in bulk.
				<br />
				<br />
				Ideal for adding hosts of a similar type quickly.
				<br />
				<br />
				It does <b>NOT</b> add services.
				<br />
				<br />
				You need a list of hosts, their addresses and optionally a description in a spreadsheet / CSV format.
				<br />
				<br />
				The address can be an IP Address or a FQDN.
				<br />
				<br />
				The host name and the description can contain spaces.
				<br />
				<br />
				The format is &lt;address&gt;<b>,</b>&lt;host name&gt;<b>,</b>&lt;description&gt;
				<br />
				If you did not want a description then the format is &lt;address&gt;<b>,</b>&lt;host name&gt;
				<br />
				<br />
				<i>Here are some examples:</i>
				<br />
				<br />
				<b>VMware ESX Servers</b>
				<br />
				esx1.yourdomain.local<b>,</b>ESX1<b>,</b>ESX1 - Production
				<br />
				esx2.yourdomain.local<b>,</b>ESX2<b>,</b>ESX2 - Production
				<br />
				esx3.yourdomain.local<b>,</b>ESX3<b>,</b>ESX3 - Production
				<br />
				esx4.yourdomain.local<b>,</b>ESX4<b>,</b>ESX4 - Testing
				<br />
				esx5.yourdomain.local<b>,</b>ESX5<b>,</b>ESX5 - Testing
				<br />
				<br />
				<b>Windows Servers</b>
				<br />
				192.168.111.50<b>,</b>SERVER01<b>,</b>Active Directory
				<br />
				192.168.111.51<b>,</b>SERVER02<b>,</b>Active Directory
				<br />
				email.yourdomain.local<b>,</b>SERVER04
				<br />
				192.168.111.55<b>,</b>SERVER05
				<br />
				192.168.111.38<b>,</b>SERVER06<b>,</b>Email
				<br />
				192.168.111.40<b>,</b>SERVER17
				<br />
				<br />
				<b>Note</b>: Make sure the address, host name or description does NOT contain a <b>,</b>
				<br />
				The comma is only to be used to separate the address, host name and description columns.
				<br />
				<br />
				<i>Handy tip:</i> Create a CSV file in your favourite spreadsheet program. Open this file in a basic text editor, copy the contents and paste them into the User Input area.
				<br />
				<br />
				<br />
			</div> 
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para2\')" value="Characters">
			</div>
			<div id="para2" style="display:none">
				<br />
				<b>CasE SenSATiViTY</b>
				<br />
				<br />
				All characters in Nagios XI are case sensative.
				<br />
				<br />
				<b>This</b> and <b>this</b> and <b>THIS</b> and <b>thiS</b> are completely different.
				<br />
				<br />
				<b>Allowed Characters</b>
				<br />
				<table border="0" cellspacing="10" bordercolor="white">
					<tr><td>A - Z, a - z, and 0 - 9</tr></td>
					<tr><td>- _ [ ] / : .</tr></td>
				</table>
				<br />
				Additionally it has been identified that if your host name contains <b>[</b> or <b>]</b> it will prevent performance graphs from being generated. <i>Issue identified by Nagios Support Forum user htel</i>.
				<br />
				<br />
			</div>
			
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para900\')" value="Discount Offer">
			</div>
			<div id="para900" style="display:none">
				<br />
				Get a <b>10%</b> discount on your Nagios XI Unlimited Nodes license when purchased through <a href="http://www.nagios.com/nagiosxi10?ref=box293" target="_blank"><b>this link</b></a>.
				<br />
				<br />
			</div>
			
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para910\')" value="License">
			</div>
			<div id="para910" style="display:none">
			<h3 style="text-align: center;">GNU GENERAL PUBLIC LICENSE</h3>
			<p style="text-align: center;">Version 3, 29 June 2007</p>

			<p>Copyright &copy; 2007 Free Software Foundation, Inc.
			 &lt;<a href="http://fsf.org/">http://fsf.org/</a>&gt;</p><p>
			 Everyone is permitted to copy and distribute verbatim copies
			 of this license document, but changing it is not allowed.</p>

			<h3><a name="preamble"></a>Preamble</h3>

			<p>The GNU General Public License is a free, copyleft license for
			software and other kinds of works.</p>

			<p>The licenses for most software and other practical works are designed
			to take away your freedom to share and change the works.  By contrast,
			the GNU General Public License is intended to guarantee your freedom to
			share and change all versions of a program--to make sure it remains free
			software for all its users.  We, the Free Software Foundation, use the
			GNU General Public License for most of our software; it applies also to
			any other work released this way by its authors.  You can apply it to
			your programs, too.</p>

			<p>When we speak of free software, we are referring to freedom, not
			price.  Our General Public Licenses are designed to make sure that you
			have the freedom to distribute copies of free software (and charge for
			them if you wish), that you receive source code or can get it if you
			want it, that you can change the software or use pieces of it in new
			free programs, and that you know you can do these things.</p>

			<p>To protect your rights, we need to prevent others from denying you
			these rights or asking you to surrender the rights.  Therefore, you have
			certain responsibilities if you distribute copies of the software, or if
			you modify it: responsibilities to respect the freedom of others.</p>

			<p>For example, if you distribute copies of such a program, whether
			gratis or for a fee, you must pass on to the recipients the same
			freedoms that you received.  You must make sure that they, too, receive
			or can get the source code.  And you must show them these terms so they
			know their rights.</p>

			<p>Developers that use the GNU GPL protect your rights with two steps:
			(1) assert copyright on the software, and (2) offer you this License
			giving you legal permission to copy, distribute and/or modify it.</p>

			<p>For the developers\' and authors\' protection, the GPL clearly explains
			that there is no warranty for this free software.  For both users\' and
			authors\' sake, the GPL requires that modified versions be marked as
			changed, so that their problems will not be attributed erroneously to
			authors of previous versions.</p>

			<p>Some devices are designed to deny users access to install or run
			modified versions of the software inside them, although the manufacturer
			can do so.  This is fundamentally incompatible with the aim of
			protecting users\' freedom to change the software.  The systematic
			pattern of such abuse occurs in the area of products for individuals to
			use, which is precisely where it is most unacceptable.  Therefore, we
			have designed this version of the GPL to prohibit the practice for those
			products.  If such problems arise substantially in other domains, we
			stand ready to extend this provision to those domains in future versions
			of the GPL, as needed to protect the freedom of users.</p>

			<p>Finally, every program is threatened constantly by software patents.
			States should not allow patents to restrict development and use of
			software on general-purpose computers, but in those that do, we wish to
			avoid the special danger that patents applied to a free program could
			make it effectively proprietary.  To prevent this, the GPL assures that
			patents cannot be used to render the program non-free.</p>

			<p>The precise terms and conditions for copying, distribution and
			modification follow.</p>

			<h3><a name="terms"></a>TERMS AND CONDITIONS</h3>

			<h4><a name="section0"></a>0. Definitions.</h4>

			<p>&ldquo;This License&rdquo; refers to version 3 of the GNU General Public License.</p>

			<p>&ldquo;Copyright&rdquo; also means copyright-like laws that apply to other kinds of
			works, such as semiconductor masks.</p>
			 
			<p>&ldquo;The Program&rdquo; refers to any copyrightable work licensed under this
			License.  Each licensee is addressed as &ldquo;you&rdquo;.  &ldquo;Licensees&rdquo; and
			&ldquo;recipients&rdquo; may be individuals or organizations.</p>

			<p>To &ldquo;modify&rdquo; a work means to copy from or adapt all or part of the work
			in a fashion requiring copyright permission, other than the making of an
			exact copy.  The resulting work is called a &ldquo;modified version&rdquo; of the
			earlier work or a work &ldquo;based on&rdquo; the earlier work.</p>

			<p>A &ldquo;covered work&rdquo; means either the unmodified Program or a work based
			on the Program.</p>

			<p>To &ldquo;propagate&rdquo; a work means to do anything with it that, without
			permission, would make you directly or secondarily liable for
			infringement under applicable copyright law, except executing it on a
			computer or modifying a private copy.  Propagation includes copying,
			distribution (with or without modification), making available to the
			public, and in some countries other activities as well.</p>

			<p>To &ldquo;convey&rdquo; a work means any kind of propagation that enables other
			parties to make or receive copies.  Mere interaction with a user through
			a computer network, with no transfer of a copy, is not conveying.</p>

			<p>An interactive user interface displays &ldquo;Appropriate Legal Notices&rdquo;
			to the extent that it includes a convenient and prominently visible
			feature that (1) displays an appropriate copyright notice, and (2)
			tells the user that there is no warranty for the work (except to the
			extent that warranties are provided), that licensees may convey the
			work under this License, and how to view a copy of this License.  If
			the interface presents a list of user commands or options, such as a
			menu, a prominent item in the list meets this criterion.</p>

			<h4><a name="section1"></a>1. Source Code.</h4>

			<p>The &ldquo;source code&rdquo; for a work means the preferred form of the work
			for making modifications to it.  &ldquo;Object code&rdquo; means any non-source
			form of a work.</p>

			<p>A &ldquo;Standard Interface&rdquo; means an interface that either is an official
			standard defined by a recognized standards body, or, in the case of
			interfaces specified for a particular programming language, one that
			is widely used among developers working in that language.</p>

			<p>The &ldquo;System Libraries&rdquo; of an executable work include anything, other
			than the work as a whole, that (a) is included in the normal form of
			packaging a Major Component, but which is not part of that Major
			Component, and (b) serves only to enable use of the work with that
			Major Component, or to implement a Standard Interface for which an
			implementation is available to the public in source code form.  A
			&ldquo;Major Component&rdquo;, in this context, means a major essential component
			(kernel, window system, and so on) of the specific operating system
			(if any) on which the executable work runs, or a compiler used to
			produce the work, or an object code interpreter used to run it.</p>

			<p>The &ldquo;Corresponding Source&rdquo; for a work in object code form means all
			the source code needed to generate, install, and (for an executable
			work) run the object code and to modify the work, including scripts to
			control those activities.  However, it does not include the work\'s
			System Libraries, or general-purpose tools or generally available free
			programs which are used unmodified in performing those activities but
			which are not part of the work.  For example, Corresponding Source
			includes interface definition files associated with source files for
			the work, and the source code for shared libraries and dynamically
			linked subprograms that the work is specifically designed to require,
			such as by intimate data communication or control flow between those
			subprograms and other parts of the work.</p>

			<p>The Corresponding Source need not include anything that users
			can regenerate automatically from other parts of the Corresponding
			Source.</p>

			<p>The Corresponding Source for a work in source code form is that
			same work.</p>

			<h4><a name="section2"></a>2. Basic Permissions.</h4>

			<p>All rights granted under this License are granted for the term of
			copyright on the Program, and are irrevocable provided the stated
			conditions are met.  This License explicitly affirms your unlimited
			permission to run the unmodified Program.  The output from running a
			covered work is covered by this License only if the output, given its
			content, constitutes a covered work.  This License acknowledges your
			rights of fair use or other equivalent, as provided by copyright law.</p>

			<p>You may make, run and propagate covered works that you do not
			convey, without conditions so long as your license otherwise remains
			in force.  You may convey covered works to others for the sole purpose
			of having them make modifications exclusively for you, or provide you
			with facilities for running those works, provided that you comply with
			the terms of this License in conveying all material for which you do
			not control copyright.  Those thus making or running the covered works
			for you must do so exclusively on your behalf, under your direction
			and control, on terms that prohibit them from making any copies of
			your copyrighted material outside their relationship with you.</p>

			<p>Conveying under any other circumstances is permitted solely under
			the conditions stated below.  Sublicensing is not allowed; section 10
			makes it unnecessary.</p>

			<h4><a name="section3"></a>3. Protecting Users\' Legal Rights From Anti-Circumvention Law.</h4>

			<p>No covered work shall be deemed part of an effective technological
			measure under any applicable law fulfilling obligations under article
			11 of the WIPO copyright treaty adopted on 20 December 1996, or
			similar laws prohibiting or restricting circumvention of such
			measures.</p>

			<p>When you convey a covered work, you waive any legal power to forbid
			circumvention of technological measures to the extent such circumvention
			is effected by exercising rights under this License with respect to
			the covered work, and you disclaim any intention to limit operation or
			modification of the work as a means of enforcing, against the work\'s
			users, your or third parties\' legal rights to forbid circumvention of
			technological measures.</p>

			<h4><a name="section4"></a>4. Conveying Verbatim Copies.</h4>

			<p>You may convey verbatim copies of the Program\'s source code as you
			receive it, in any medium, provided that you conspicuously and
			appropriately publish on each copy an appropriate copyright notice;
			keep intact all notices stating that this License and any
			non-permissive terms added in accord with section 7 apply to the code;
			keep intact all notices of the absence of any warranty; and give all
			recipients a copy of this License along with the Program.</p>

			<p>You may charge any price or no price for each copy that you convey,
			and you may offer support or warranty protection for a fee.</p>

			<h4><a name="section5"></a>5. Conveying Modified Source Versions.</h4>

			<p>You may convey a work based on the Program, or the modifications to
			produce it from the Program, in the form of source code under the
			terms of section 4, provided that you also meet all of these conditions:</p>

			<ul>
			<li>a) The work must carry prominent notices stating that you modified
				it, and giving a relevant date.</li>

			<li>b) The work must carry prominent notices stating that it is
				released under this License and any conditions added under section
				7.  This requirement modifies the requirement in section 4 to
				&ldquo;keep intact all notices&rdquo;.</li>

			<li>c) You must license the entire work, as a whole, under this
				License to anyone who comes into possession of a copy.  This
				License will therefore apply, along with any applicable section 7
				additional terms, to the whole of the work, and all its parts,
				regardless of how they are packaged.  This License gives no
				permission to license the work in any other way, but it does not
				invalidate such permission if you have separately received it.</li>

			<li>d) If the work has interactive user interfaces, each must display
				Appropriate Legal Notices; however, if the Program has interactive
				interfaces that do not display Appropriate Legal Notices, your
				work need not make them do so.</li>
			</ul>

			<p>A compilation of a covered work with other separate and independent
			works, which are not by their nature extensions of the covered work,
			and which are not combined with it such as to form a larger program,
			in or on a volume of a storage or distribution medium, is called an
			&ldquo;aggregate&rdquo; if the compilation and its resulting copyright are not
			used to limit the access or legal rights of the compilation\'s users
			beyond what the individual works permit.  Inclusion of a covered work
			in an aggregate does not cause this License to apply to the other
			parts of the aggregate.</p>

			<h4><a name="section6"></a>6. Conveying Non-Source Forms.</h4>

			<p>You may convey a covered work in object code form under the terms
			of sections 4 and 5, provided that you also convey the
			machine-readable Corresponding Source under the terms of this License,
			in one of these ways:</p>

			<ul>
			<li>a) Convey the object code in, or embodied in, a physical product
				(including a physical distribution medium), accompanied by the
				Corresponding Source fixed on a durable physical medium
				customarily used for software interchange.</li>

			<li>b) Convey the object code in, or embodied in, a physical product
				(including a physical distribution medium), accompanied by a
				written offer, valid for at least three years and valid for as
				long as you offer spare parts or customer support for that product
				model, to give anyone who possesses the object code either (1) a
				copy of the Corresponding Source for all the software in the
				product that is covered by this License, on a durable physical
				medium customarily used for software interchange, for a price no
				more than your reasonable cost of physically performing this
				conveying of source, or (2) access to copy the
				Corresponding Source from a network server at no charge.</li>

			<li>c) Convey individual copies of the object code with a copy of the
				written offer to provide the Corresponding Source.  This
				alternative is allowed only occasionally and noncommercially, and
				only if you received the object code with such an offer, in accord
				with subsection 6b.</li>

			<li>d) Convey the object code by offering access from a designated
				place (gratis or for a charge), and offer equivalent access to the
				Corresponding Source in the same way through the same place at no
				further charge.  You need not require recipients to copy the
				Corresponding Source along with the object code.  If the place to
				copy the object code is a network server, the Corresponding Source
				may be on a different server (operated by you or a third party)
				that supports equivalent copying facilities, provided you maintain
				clear directions next to the object code saying where to find the
				Corresponding Source.  Regardless of what server hosts the
				Corresponding Source, you remain obligated to ensure that it is
				available for as long as needed to satisfy these requirements.</li>

			<li>e) Convey the object code using peer-to-peer transmission, provided
				you inform other peers where the object code and Corresponding
				Source of the work are being offered to the general public at no
				charge under subsection 6d.</li>
			</ul>

			<p>A separable portion of the object code, whose source code is excluded
			from the Corresponding Source as a System Library, need not be
			included in conveying the object code work.</p>

			<p>A &ldquo;User Product&rdquo; is either (1) a &ldquo;consumer product&rdquo;, which means any
			tangible personal property which is normally used for personal, family,
			or household purposes, or (2) anything designed or sold for incorporation
			into a dwelling.  In determining whether a product is a consumer product,
			doubtful cases shall be resolved in favor of coverage.  For a particular
			product received by a particular user, &ldquo;normally used&rdquo; refers to a
			typical or common use of that class of product, regardless of the status
			of the particular user or of the way in which the particular user
			actually uses, or expects or is expected to use, the product.  A product
			is a consumer product regardless of whether the product has substantial
			commercial, industrial or non-consumer uses, unless such uses represent
			the only significant mode of use of the product.</p>

			<p>&ldquo;Installation Information&rdquo; for a User Product means any methods,
			procedures, authorization keys, or other information required to install
			and execute modified versions of a covered work in that User Product from
			a modified version of its Corresponding Source.  The information must
			suffice to ensure that the continued functioning of the modified object
			code is in no case prevented or interfered with solely because
			modification has been made.</p>

			<p>If you convey an object code work under this section in, or with, or
			specifically for use in, a User Product, and the conveying occurs as
			part of a transaction in which the right of possession and use of the
			User Product is transferred to the recipient in perpetuity or for a
			fixed term (regardless of how the transaction is characterized), the
			Corresponding Source conveyed under this section must be accompanied
			by the Installation Information.  But this requirement does not apply
			if neither you nor any third party retains the ability to install
			modified object code on the User Product (for example, the work has
			been installed in ROM).</p>

			<p>The requirement to provide Installation Information does not include a
			requirement to continue to provide support service, warranty, or updates
			for a work that has been modified or installed by the recipient, or for
			the User Product in which it has been modified or installed.  Access to a
			network may be denied when the modification itself materially and
			adversely affects the operation of the network or violates the rules and
			protocols for communication across the network.</p>

			<p>Corresponding Source conveyed, and Installation Information provided,
			in accord with this section must be in a format that is publicly
			documented (and with an implementation available to the public in
			source code form), and must require no special password or key for
			unpacking, reading or copying.</p>

			<h4><a name="section7"></a>7. Additional Terms.</h4>

			<p>&ldquo;Additional permissions&rdquo; are terms that supplement the terms of this
			License by making exceptions from one or more of its conditions.
			Additional permissions that are applicable to the entire Program shall
			be treated as though they were included in this License, to the extent
			that they are valid under applicable law.  If additional permissions
			apply only to part of the Program, that part may be used separately
			under those permissions, but the entire Program remains governed by
			this License without regard to the additional permissions.</p>

			<p>When you convey a copy of a covered work, you may at your option
			remove any additional permissions from that copy, or from any part of
			it.  (Additional permissions may be written to require their own
			removal in certain cases when you modify the work.)  You may place
			additional permissions on material, added by you to a covered work,
			for which you have or can give appropriate copyright permission.</p>

			<p>Notwithstanding any other provision of this License, for material you
			add to a covered work, you may (if authorized by the copyright holders of
			that material) supplement the terms of this License with terms:</p>

			<ul>
			<li>a) Disclaiming warranty or limiting liability differently from the
				terms of sections 15 and 16 of this License; or</li>

			<li>b) Requiring preservation of specified reasonable legal notices or
				author attributions in that material or in the Appropriate Legal
				Notices displayed by works containing it; or</li>

			<li>c) Prohibiting misrepresentation of the origin of that material, or
				requiring that modified versions of such material be marked in
				reasonable ways as different from the original version; or</li>

			<li>d) Limiting the use for publicity purposes of names of licensors or
				authors of the material; or</li>

			<li>e) Declining to grant rights under trademark law for use of some
				trade names, trademarks, or service marks; or</li>

			<li>f) Requiring indemnification of licensors and authors of that
				material by anyone who conveys the material (or modified versions of
				it) with contractual assumptions of liability to the recipient, for
				any liability that these contractual assumptions directly impose on
				those licensors and authors.</li>
			</ul>

			<p>All other non-permissive additional terms are considered &ldquo;further
			restrictions&rdquo; within the meaning of section 10.  If the Program as you
			received it, or any part of it, contains a notice stating that it is
			governed by this License along with a term that is a further
			restriction, you may remove that term.  If a license document contains
			a further restriction but permits relicensing or conveying under this
			License, you may add to a covered work material governed by the terms
			of that license document, provided that the further restriction does
			not survive such relicensing or conveying.</p>

			<p>If you add terms to a covered work in accord with this section, you
			must place, in the relevant source files, a statement of the
			additional terms that apply to those files, or a notice indicating
			where to find the applicable terms.</p>

			<p>Additional terms, permissive or non-permissive, may be stated in the
			form of a separately written license, or stated as exceptions;
			the above requirements apply either way.</p>

			<h4><a name="section8"></a>8. Termination.</h4>

			<p>You may not propagate or modify a covered work except as expressly
			provided under this License.  Any attempt otherwise to propagate or
			modify it is void, and will automatically terminate your rights under
			this License (including any patent licenses granted under the third
			paragraph of section 11).</p>

			<p>However, if you cease all violation of this License, then your
			license from a particular copyright holder is reinstated (a)
			provisionally, unless and until the copyright holder explicitly and
			finally terminates your license, and (b) permanently, if the copyright
			holder fails to notify you of the violation by some reasonable means
			prior to 60 days after the cessation.</p>

			<p>Moreover, your license from a particular copyright holder is
			reinstated permanently if the copyright holder notifies you of the
			violation by some reasonable means, this is the first time you have
			received notice of violation of this License (for any work) from that
			copyright holder, and you cure the violation prior to 30 days after
			your receipt of the notice.</p>

			<p>Termination of your rights under this section does not terminate the
			licenses of parties who have received copies or rights from you under
			this License.  If your rights have been terminated and not permanently
			reinstated, you do not qualify to receive new licenses for the same
			material under section 10.</p>

			<h4><a name="section9"></a>9. Acceptance Not Required for Having Copies.</h4>

			<p>You are not required to accept this License in order to receive or
			run a copy of the Program.  Ancillary propagation of a covered work
			occurring solely as a consequence of using peer-to-peer transmission
			to receive a copy likewise does not require acceptance.  However,
			nothing other than this License grants you permission to propagate or
			modify any covered work.  These actions infringe copyright if you do
			not accept this License.  Therefore, by modifying or propagating a
			covered work, you indicate your acceptance of this License to do so.</p>

			<h4><a name="section10"></a>10. Automatic Licensing of Downstream Recipients.</h4>

			<p>Each time you convey a covered work, the recipient automatically
			receives a license from the original licensors, to run, modify and
			propagate that work, subject to this License.  You are not responsible
			for enforcing compliance by third parties with this License.</p>

			<p>An &ldquo;entity transaction&rdquo; is a transaction transferring control of an
			organization, or substantially all assets of one, or subdividing an
			organization, or merging organizations.  If propagation of a covered
			work results from an entity transaction, each party to that
			transaction who receives a copy of the work also receives whatever
			licenses to the work the party\'s predecessor in interest had or could
			give under the previous paragraph, plus a right to possession of the
			Corresponding Source of the work from the predecessor in interest, if
			the predecessor has it or can get it with reasonable efforts.</p>

			<p>You may not impose any further restrictions on the exercise of the
			rights granted or affirmed under this License.  For example, you may
			not impose a license fee, royalty, or other charge for exercise of
			rights granted under this License, and you may not initiate litigation
			(including a cross-claim or counterclaim in a lawsuit) alleging that
			any patent claim is infringed by making, using, selling, offering for
			sale, or importing the Program or any portion of it.</p>

			<h4><a name="section11"></a>11. Patents.</h4>

			<p>A &ldquo;contributor&rdquo; is a copyright holder who authorizes use under this
			License of the Program or a work on which the Program is based.  The
			work thus licensed is called the contributor\'s &ldquo;contributor version&rdquo;.</p>

			<p>A contributor\'s &ldquo;essential patent claims&rdquo; are all patent claims
			owned or controlled by the contributor, whether already acquired or
			hereafter acquired, that would be infringed by some manner, permitted
			by this License, of making, using, or selling its contributor version,
			but do not include claims that would be infringed only as a
			consequence of further modification of the contributor version.  For
			purposes of this definition, &ldquo;control&rdquo; includes the right to grant
			patent sublicenses in a manner consistent with the requirements of
			this License.</p>

			<p>Each contributor grants you a non-exclusive, worldwide, royalty-free
			patent license under the contributor\'s essential patent claims, to
			make, use, sell, offer for sale, import and otherwise run, modify and
			propagate the contents of its contributor version.</p>

			<p>In the following three paragraphs, a &ldquo;patent license&rdquo; is any express
			agreement or commitment, however denominated, not to enforce a patent
			(such as an express permission to practice a patent or covenant not to
			sue for patent infringement).  To &ldquo;grant&rdquo; such a patent license to a
			party means to make such an agreement or commitment not to enforce a
			patent against the party.</p>

			<p>If you convey a covered work, knowingly relying on a patent license,
			and the Corresponding Source of the work is not available for anyone
			to copy, free of charge and under the terms of this License, through a
			publicly available network server or other readily accessible means,
			then you must either (1) cause the Corresponding Source to be so
			available, or (2) arrange to deprive yourself of the benefit of the
			patent license for this particular work, or (3) arrange, in a manner
			consistent with the requirements of this License, to extend the patent
			license to downstream recipients.  &ldquo;Knowingly relying&rdquo; means you have
			actual knowledge that, but for the patent license, your conveying the
			covered work in a country, or your recipient\'s use of the covered work
			in a country, would infringe one or more identifiable patents in that
			country that you have reason to believe are valid.</p>
			  
			<p>If, pursuant to or in connection with a single transaction or
			arrangement, you convey, or propagate by procuring conveyance of, a
			covered work, and grant a patent license to some of the parties
			receiving the covered work authorizing them to use, propagate, modify
			or convey a specific copy of the covered work, then the patent license
			you grant is automatically extended to all recipients of the covered
			work and works based on it.</p>

			<p>A patent license is &ldquo;discriminatory&rdquo; if it does not include within
			the scope of its coverage, prohibits the exercise of, or is
			conditioned on the non-exercise of one or more of the rights that are
			specifically granted under this License.  You may not convey a covered
			work if you are a party to an arrangement with a third party that is
			in the business of distributing software, under which you make payment
			to the third party based on the extent of your activity of conveying
			the work, and under which the third party grants, to any of the
			parties who would receive the covered work from you, a discriminatory
			patent license (a) in connection with copies of the covered work
			conveyed by you (or copies made from those copies), or (b) primarily
			for and in connection with specific products or compilations that
			contain the covered work, unless you entered into that arrangement,
			or that patent license was granted, prior to 28 March 2007.</p>

			<p>Nothing in this License shall be construed as excluding or limiting
			any implied license or other defenses to infringement that may
			otherwise be available to you under applicable patent law.</p>

			<h4><a name="section12"></a>12. No Surrender of Others\' Freedom.</h4>

			<p>If conditions are imposed on you (whether by court order, agreement or
			otherwise) that contradict the conditions of this License, they do not
			excuse you from the conditions of this License.  If you cannot convey a
			covered work so as to satisfy simultaneously your obligations under this
			License and any other pertinent obligations, then as a consequence you may
			not convey it at all.  For example, if you agree to terms that obligate you
			to collect a royalty for further conveying from those to whom you convey
			the Program, the only way you could satisfy both those terms and this
			License would be to refrain entirely from conveying the Program.</p>

			<h4><a name="section13"></a>13. Use with the GNU Affero General Public License.</h4>

			<p>Notwithstanding any other provision of this License, you have
			permission to link or combine any covered work with a work licensed
			under version 3 of the GNU Affero General Public License into a single
			combined work, and to convey the resulting work.  The terms of this
			License will continue to apply to the part which is the covered work,
			but the special requirements of the GNU Affero General Public License,
			section 13, concerning interaction through a network will apply to the
			combination as such.</p>

			<h4><a name="section14"></a>14. Revised Versions of this License.</h4>

			<p>The Free Software Foundation may publish revised and/or new versions of
			the GNU General Public License from time to time.  Such new versions will
			be similar in spirit to the present version, but may differ in detail to
			address new problems or concerns.</p>

			<p>Each version is given a distinguishing version number.  If the
			Program specifies that a certain numbered version of the GNU General
			Public License &ldquo;or any later version&rdquo; applies to it, you have the
			option of following the terms and conditions either of that numbered
			version or of any later version published by the Free Software
			Foundation.  If the Program does not specify a version number of the
			GNU General Public License, you may choose any version ever published
			by the Free Software Foundation.</p>

			<p>If the Program specifies that a proxy can decide which future
			versions of the GNU General Public License can be used, that proxy\'s
			public statement of acceptance of a version permanently authorizes you
			to choose that version for the Program.</p>

			<p>Later license versions may give you additional or different
			permissions.  However, no additional obligations are imposed on any
			author or copyright holder as a result of your choosing to follow a
			later version.</p>

			<h4><a name="section15"></a>15. Disclaimer of Warranty.</h4>

			<p>THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
			APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
			HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM &ldquo;AS IS&rdquo; WITHOUT WARRANTY
			OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
			THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
			PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
			IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
			ALL NECESSARY SERVICING, REPAIR OR CORRECTION.</p>

			<h4><a name="section16"></a>16. Limitation of Liability.</h4>

			<p>IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
			WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
			THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
			GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
			USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
			DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
			PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
			EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
			SUCH DAMAGES.</p>

			<h4><a name="section17"></a>17. Interpretation of Sections 15 and 16.</h4>

			<p>If the disclaimer of warranty and limitation of liability provided
			above cannot be given local legal effect according to their terms,
			reviewing courts shall apply local law that most closely approximates
			an absolute waiver of all civil liability in connection with the
			Program, unless a warranty or assumption of liability accompanies a
			copy of the Program in return for a fee.</p>

			<p>END OF TERMS AND CONDITIONS</p>
			<br>
			</div>
						
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para920\')" value="Project Hours">
			</div>
			<div id="para920" style="display:none">
				<br />
				Approximately 50 hours have been spent on this project.
				<br />
				<br />
			</div>
			
			</div> <!-- This is the end of the div for width -->
			
			<div class="sectionTitle">Host Type</div>
			<p>
			Please choose the host type would you like to create:
			<br />
			';
			/* This code builds a table of wizards that are installed */
			$knownwizards_table = '<table cellspacing="2">';
			$knownwizards_table .= '<tr>';
			$columns = 3; 
			$rowcount = count($knownwizards); 
			$rows = floor($rowcount / $columns); 
			$rowdata = array_fill(0, $rows, ''); 
			$ctr = 0; 
			foreach ($knownwizards as $wizardfile => $wizardname) {
				/* Check to see if this wizard is installed */
				$wizardfilefull = '../includes/configwizards/' . $wizardfile . '/' . $wizardfile . '.inc.php';
				if (file_exists($wizardfilefull)) {
					$wizardicon = '../includes/components/nagioscore/ui/images/logos/'.$knownicons[$wizardfile];
					//print_r('<br />'.$wizardfile.'<br />');
					if ($wizardfile == 'linux-server') {
						$note = '<sup>#</sup> ';
						}
					else if ($wizardfile == 'nrpe' or $wizardfile == 'sshproxy') {
						$note = '<sup>##</sup> ';
						}
					else {
						$note = '';
						}
					if ($host_type == $wizardfile) { $checked = 'checked="checked"'; } else {$checked = '';}
					$rowdata[$ctr++ % $rows] .= '
						<td class="paddingright20">
						<img style="vertical-align:middle" src="'.$wizardicon.'">
						<input type="radio" name="host_type" value="'.$wizardfile.'" '.$checked.'/>
						'.$note.''.$wizardname.'
						</td>
						'; 
					}
				}
			$knownwizards_table .= '<tr>'.implode('</tr><tr>',$rowdata).'</tr>'; 
			$knownwizards_table .= '</tr>';
			$knownwizards_table .= '</table>';
			
			$output .= '
			'.$knownwizards_table.'
			</p>
			<div style="width: 600px;"> <!-- This div sets the width -->
			<p>
			<table>
				<tr>
					<td>
						<sup>#</sup> <i>Required for Linux Server</i>
					</td>
					<td>
						<sup>##</sup> <i>Required for NRPE AND SSH Proxy</i>
					</td>
				</tr>
				<tr>
					<td class="paddingright20">
						<select name="linuxdistroselect" id="linuxdistroselect">
							<option value="'.$linuxdistroselect.'">'.$linuxdistroselect.'</option>
							<option value="CentOS">CentOS</option>
							<option value="Debian">Debian</option>
							<option value="Fedora">Fedora Core</option>
							<option value="Other">Other</option>
							<option value="RHEL">RedHat Enterprise Linux</option>
							<option value="Ubuntu">Ubuntu</option>
						</select>
					</td>
					<td class="paddingright20">
						<select name="osdistroselect" id="osdistroselect">
							<option value="'.$osdistroselect.'">'.$osdistroselect.'</option>
							<option value="AIX">AIX</option>
							<option value="CentOS">CentOS</option>
							<option value="Debian">Debian</option>
							<option value="Fedora">Fedora Core</option>
							<option value="FreeBSD">FreeBSD</option>
							<option value="HP-UX">HP-UX</option>
							<option value="Linux">Linux Other</option>
							<option value="NetBSD">NetBSD</option>
							<option value="OpenBSD">OpenBSD</option>
							<option value="RHEL">RedHat Enterprise Linux</option>
							<option value="Solaris">Solaris</option>
							<option value="Ubuntu">Ubuntu</option>
							<option value="Windows">Windows</option>
						</select>
					</td>
			</tr>
			</table>
			</p>
			
			<div class="sectionTitle">List Of Hosts</div>
			<p>
			Please type or paste host addresses (IP Address or FQDN) and host names in a CSV format.
			<br />
			<br />
			The format is &lt;address&gt;<b>,</b>&lt;host name&gt;<b>,</b>&lt;description&gt;
			<br />
			<br />
			If you did not want a description then the format is &lt;address&gt;<b>,</b>&lt;host name&gt;
			<br />
			<br />
			The comma is only to be used to separate the address, host name and description columns.
			<br />
			<br />
			<b>User Input</b>
			<br />
			<textarea cols="60" rows="15" wrap="off" name="userinput" id="userinput">'.$userinput.'</textarea>
			</p>
			
			<br />
			<p>
			Click <b>Next</b> to continue.
			</p>
			</div> <!-- This is the end of the div for width -->
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE1HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE1HTML */
			break;

			
		/* Form validation for CONFIGWIZARD_MODE_GETSTAGE1HTML */
		case CONFIGWIZARD_MODE_VALIDATESTAGE1DATA:		
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE2HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 	
			
			/* If the user came back from CONFIGWIZARD_MODE_GETSTAGE3HTML then we don't need to revalidate and check for errors */
			if ($back) break;	
			
			/* Get variables that were passed to us */
				/* NOTE: grab_array_var is an XI wrapper function to fetch values 'if they exist' */
				/* USAGE: grab_array_var($array, $variable, $defaultValue) */
			$host_type = grab_array_var($inargs,'host_type','');
			$userinput = grab_array_var($inargs,'userinput','');
			$linuxdistroselect = grab_array_var($inargs,'linuxdistroselect','');
			$osdistroselect = grab_array_var($inargs,'osdistroselect','');
			
			/* Now lets check for errors before proceeding to CONFIGWIZARD_MODE_GETSTAGE2HTML*/
			/* Set the error count to 0 */
			$errors = 0;
			
			/* Create the error messages array */
			$errmsg = array();
			
			/* Create the array for the new hosts */
			$newhost=array();
			
			/* Check to see if the host_type radio was selected */
			if ($host_type == '') {
					/* host_type was blank, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You must select a host type.';
					}
			
			/* Check to see if the linux-server radio was selected */
			if ($host_type == 'linux-server') {
				/* Check to see if a linux-server distribution was selected */
				if ($linuxdistroselect == '') {
					/* linuxdistroselect was not selected, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You selected Linux Server however you did not select a Linux Distribution.'; 
					}
				}
			
			/* Check to see if the nrpe radio was selected */
			if ($host_type == 'nrpe') {
				/* Check to see if an os distribution was selected */
				if ($osdistroselect == '') {
					/* osdistroselect was not selected, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You selected NRPE however you did not select an OS Distribution.'; 
					}
				}
			
			/* Check to see if the sshproxy radio was selected */
			if ($host_type == 'sshproxy') {
				/* Check to see if an os distribution was selected */
				if ($osdistroselect == '') {
					/* osdistroselect was not selected, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You selected SSH Proxy however you did not select an OS Distribution.'; 
					}
				}
			
			/* Check to see if the any userinput data was provided */
			if ($userinput == '') {
					/* userinput was blank, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You must provide user input data.';
					}
			else {
				/* Check the csv data that was provided */
				// get rid of whitespace and the \r
				$text = str_replace("\r", '', trim($userinput));
				$lines = explode("\n", $text);
				foreach ($lines as $line) {
					$parts = explode(',', $line);
					if (have_value($parts[0])==false)
						$errmsg[$errors++]="No address specified.";
					else if (!valid_ip($parts[0]))
						$errmsg[$errors++]="Invalid IP Address: $parts[0].";
					else if (preg_match('[\s]',$parts[0]))
						$errmsg[$errors++]="IP Address or FQDN has a space: $parts[0].";
					else if (have_value($parts[1])==false)
						$errmsg[$errors++]="No Host Name specified for $parts[0].";
					else if (preg_match('/[^0-9a-zA-Z\ \.\:\_\-\[\]]/',$parts[1]))
						$errmsg[$errors++]="Host Name $parts[1] contains invalid characters.";
					else if (isset($parts[2]))
						if (preg_match('/[^0-9a-zA-Z\ \.\:\_\-\[\]]/',$parts[2]))
						$errmsg[$errors++]="Description $parts[2] contains invalid characters.";
					}
				}
			
			/* Check to see if the $errors array contains errors */
			if ($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES] = $errmsg;
				$result = 1;
				}
			
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE1DATA */
			break;

			
		case CONFIGWIZARD_MODE_GETSTAGE2HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE3HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 		
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 

			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_SESSION); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session[hostcreationtool] CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			$knownwizards = knownwizards();
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE3HTML */
			if ($back == 'Back') {
				/* User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE3HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('<br />User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
				
				/* Back was clicked when user was on CONFIGWIZARD_MODE_GETSTAGE3HTML so we need to define some variables */
				$host_type = $_SESSION[$wizard_name]['host_type'];
				$linuxdistroselect = $_SESSION[$wizard_name]['linuxdistroselect'];
				$osdistroselect = $_SESSION[$wizard_name]['osdistroselect'];
				$userinput = $_SESSION[$wizard_name]['userinput'];
				$summaryAdd = $_SESSION[$wizard_name]['summaryAdd'];
				$summarySkip = $_SESSION[$wizard_name]['summarySkip'];
				$summaryDuplicate = $_SESSION[$wizard_name]['summaryDuplicate'];
				}
			else {
				/* Continuing from CONFIGWIZARD_MODE_GETSTAGE1HTML */
				/* OR */
				/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error */
				
				if (isset($_POST['userinput'])) {
					/* Continuing from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA<br />'); 
					
					/* Grab array variables from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$host_type = grab_array_var($inargs,'host_type','');
					$linuxdistroselect = grab_array_var($inargs,'linuxdistroselect','');
					$osdistroselect = grab_array_var($inargs,'osdistroselect','');
					$userinput = grab_array_var($inargs,'userinput','');
					
					/* We will save these to the session variable array for later use */
					$_SESSION[$wizard_name]['host_type'] = $host_type; 
					$_SESSION[$wizard_name]['linuxdistroselect'] = $linuxdistroselect; 
					$_SESSION[$wizard_name]['osdistroselect'] = $osdistroselect; 
					$_SESSION[$wizard_name]['userinput'] = $userinput; 
					
					// Destroy any session data that may have been added when the user was previously on this stage 
					unset($_SESSION[$wizard_name]['newhosts']);
					
					/* Create the summaryAddTable */
					$summaryAddTable = "<table>";			
					$summaryAddTable = $summaryAddTable . "<tr><td><b>Host Address</b></td><td class=\"width20\"></td><td><b>Host Name</b></td><td class=\"width20\"></td><td><b>Description</b></td></tr>";
					
					/* Create the summarySkipTable */
					$summarySkipTable = "<table>";			
					$summarySkipTable = $summarySkipTable . "<tr><td><b>Host Address</b></td><td class=\"width20\"></td><td><b>Host Name</b></td><td class=\"width20\"></td><td><b>Description</b></td></tr>";
					
					/* Create the summaryDuplicateTable */
					$summaryDuplicateTable = "<table>";			
					$summaryDuplicateTable = $summaryDuplicateTable . "<tr><td><b>Host Address</b></td><td class=\"width20\"></td><td><b>Host Name</b></td><td class=\"width20\"></td><td><b>Description</b></td></tr>";
										
					/* Define some variables for counting */
					$_SESSION[$wizard_name]['newhosts']['hostcount'] = -1;
					$hostsSkip = '';
					$hostsDuplicate = '';
					
					/* Now we need to check the CSV data the user provided */
					/* Get rid of whitespace and the \r */
					$text = str_replace("\r", '', trim($userinput));
					$lines = explode("\n", $text);
					/* Loop through each CSV line */
					foreach ($lines as $line) {
						$parts = explode(',', $line);
						/* Check to see if the host doesn't already exist */
						if(!host_exists($parts[1])) {
							/* We are going to check if the user is trying to add the host twice */
							$newhostnametest = 0;
							/* First check to see if the ['newhosts']['hostname'] array exists */
							if(isset($_SESSION[$wizard_name]['newhosts']['hostname'])) {
								/* If it does then loop through all the entries */
								foreach ($_SESSION[$wizard_name]['newhosts']['hostname'] as $newhostname) {
									/* Check to see if the host is being added twice */
									if ($newhostname == $parts[1]) {
										/* It is being added twice so add it to the summaryDuplicateTable */
										$summaryDuplicateTable = $summaryDuplicateTable . "<tr><td>";
										$summaryDuplicateTable = $summaryDuplicateTable . $parts[0];
										$summaryDuplicateTable = $summaryDuplicateTable . "</td><td></td><td>";
										$summaryDuplicateTable = $summaryDuplicateTable . $parts[1];
										$summaryDuplicateTable = $summaryDuplicateTable . "</td><td></td><td>";
										if (isset($parts[2]))
											$summaryDuplicateTable = $summaryDuplicateTable . $parts[2];
										$summaryDuplicateTable = $summaryDuplicateTable . "</td></tr>";
										/* Trigger the flag that the host was a duplicate */
										$hostsDuplicate++;
										$newhostnametest = 1;
										}
									}
								}
							/* Check to see if the host was detected as a duplicate */
							if ($newhostnametest == 0) {
								/* It doesn't exist so add it summaryAddTable */
								if ($_SESSION[$wizard_name]['newhosts']['hostcount'] == -1) {$_SESSION[$wizard_name]['newhosts']['hostcount'] = 0;}
								$_SESSION[$wizard_name]['newhosts']['address'][$_SESSION[$wizard_name]['newhosts']['hostcount']] = $parts[0];
								$_SESSION[$wizard_name]['newhosts']['hostname'][$_SESSION[$wizard_name]['newhosts']['hostcount']] = $parts[1];
								if (isset($parts[2]))
									$_SESSION[$wizard_name]['newhosts']['description'][$_SESSION[$wizard_name]['newhosts']['hostcount']] = $parts[2];
								$summaryAddTable = $summaryAddTable . "<tr><td>";
								$summaryAddTable = $summaryAddTable . $parts[0];
								$summaryAddTable = $summaryAddTable . "</td><td></td><td>";
								$summaryAddTable = $summaryAddTable . $parts[1];
								$summaryAddTable = $summaryAddTable . "</td><td></td><td>";
								if (isset($parts[2]))
									$summaryAddTable = $summaryAddTable . $parts[2];
								$summaryAddTable = $summaryAddTable . "</td></tr>";
								$_SESSION[$wizard_name]['newhosts']['hostcount']++;
								}
							}
						/* The host already exists so add it to the summarySkipTable */
						else {
							$summarySkipTable = $summarySkipTable . "<tr><td>";
							$summarySkipTable = $summarySkipTable . $parts[0];
							$summarySkipTable = $summarySkipTable . "</td><td></td><td>";
							$summarySkipTable = $summarySkipTable . $parts[1];
							$summarySkipTable = $summarySkipTable . "</td><td></td><td>";
							if (isset($parts[2]))
								$summarySkipTable = $summarySkipTable . $parts[2];
							$summarySkipTable = $summarySkipTable . "</td></tr>";
							$hostsSkip++;
							}
						}
					
					/* Finish the summaryAddTable */
					$summaryAddTable = $summaryAddTable . "</table>";
					
					/* Finish the summarySkipTable */
					$summarySkipTable = $summarySkipTable . "</table>";
					
					/* Finish the summaryDuplicateTable */
					$summaryDuplicateTable = $summaryDuplicateTable . "</table>";			
					
					if ($host_type == 'linux-server') {
						$distrodisplay = alldistros($linuxdistroselect);
						$linuxdistrodisplay = '<br />';
						$linuxdistrodisplay .= 'Linux Server Distribution: <b>'.$distrodisplay;
						$linuxdistrodisplay .= '</b><br />';
						$linuxdistrodisplay .= '<br />';
						}
					else {
						$linuxdistrodisplay = '';
						}
					
					if ($host_type == 'nrpe' or $host_type == 'sshproxy') {
						$distrodisplay = alldistros($osdistroselect);
						$osdistrodisplay = '<br />';
						$osdistrodisplay .= 'OS Distribution: <b>'.$distrodisplay;
						$osdistrodisplay .= '</b><br />';
						$osdistrodisplay .= '<br />';
						}
					else {
						$osdistrodisplay = '';
						}
					
					
					/* Now lets build the summary for hosts that will be added */
					$summaryAddCount = $_SESSION[$wizard_name]['newhosts']['hostcount'];
					/* Checking to see if hosts are actually going to be added */
					if ($_SESSION[$wizard_name]['newhosts']['hostcount'] != -1) {
						$summaryAdd = 'This wizard is going to add the following ';
						if ($_SESSION[$wizard_name]['newhosts']['hostcount'] == 1) {
							$summaryAdd .= 'host:';
							}
						else {
							$summaryAdd .= '<b>';
							$summaryAdd .= $_SESSION[$wizard_name]['newhosts']['hostcount'];
							$summaryAdd .= '</b> hosts:';
							}
						$summaryAdd .= '<br />';
						$summaryAdd .= '<br />';
						$summaryAdd .= $summaryAddTable;
						$summaryAdd .= '<br />';
						}
					/* No hosts are being added so we need to tell the user */
					else {
						$summaryExistsCount = count($lines);
						if ($summaryExistsCount == 1) {
							/* The user only provided one host so specific message for this */
							$summaryAdd = 'The host you chose to add already exists so it will NOT be added.';
							$summaryAdd .= '<br />';
							$summaryAdd .= '<br />';
							}
						else {
							/* Multiple hosts are not being added so specific message for this */
							$summaryAdd = 'None of the ';
							$summaryAdd .= $summaryExistsCount;
							$summaryAdd .= ' hosts you chose to add will be added as they already exist.';
							$summaryAdd .= '<br />';
							$summaryAdd .= '<br />';
							}
						}
					
					/* Define an empty summarySkip to avoid coding errors */
					$summarySkip = '';
					/* Checking to see if there are hosts that already exist and are being skipped*/
					/* First we are checking to see if NO hosts are being added. If NO hosts are */
					/* being added then we don't need to tell them as SummaryAdd has already told them this */
					if ($_SESSION[$wizard_name]['newhosts']['hostcount'] != -1) {
						if ($hostsSkip >= 1) {
							if ($hostsSkip == 1) {
								/* Only one host is being skipped so specific message for this */
								$summarySkip = 'The following host already exists so it will NOT be added:';
								}
							else if ($hostsSkip > 1) {
								/* Multiple hosts are being skipped so specific message for this */
								$summarySkip = 'The following <b>';
								$summarySkip .= $hostsSkip;
								$summarySkip .= '</b> hosts already exist so they will NOT be added:';
								}
							/* Now add the summarySkipTable */
							$summarySkip .= '<br />';
							$summarySkip .= '<br />';
							$summarySkip .= $summarySkipTable;
							$summarySkip .= '<br />';
							}
						}
					
					/* Define an empty summaryDuplicate to avoid coding errors */
					$summaryDuplicate = '';
					/* Checking to see if there are duplicate hosts that are being skipped*/
					/* First we are checking to see if NO hosts are being added. If NO hosts are */
					/* being added then we don't need to tell them as SummaryAdd has already told them this */
					if ($_SESSION[$wizard_name]['newhosts']['hostcount'] != '') {
						if ($hostsDuplicate >= 1) {
							if ($hostsDuplicate == 1) {
								/* Only one duplicate host is being skipped so specific message for this */
								$summaryDuplicate = 'You tried to add the following host twice so it will NOT be added:';
								}
							else if ($hostsDuplicate > 1) {
								/* Multiple duplicate hosts are being skipped so specific message for this */
								$summaryDuplicate = 'You tried to add the following <b>';
								$summaryDuplicate .= $hostsDuplicate;
								$summaryDuplicate .= '</b> hosts more than once so they will NOT be added:';
								}
							/* Now add the summaryDuplicateTable */
							$summaryDuplicate .= '<br />';
							$summaryDuplicate .= '<br />';
							$summaryDuplicate .= $summaryDuplicateTable;
							$summaryDuplicate .= '<br />';
							}
						}
					
			 		/* We will save these to the session variable array for coming back from CONFIGWIZARD_MODE_GETSTAGE3HTML */
					$_SESSION[$wizard_name]['summaryAdd'] = $summaryAdd; 
					$_SESSION[$wizard_name]['summarySkip'] = $summarySkip; 
					$_SESSION[$wizard_name]['summaryDuplicate'] = $summaryDuplicate; 
					$_SESSION[$wizard_name]['linuxdistrodisplay'] = $linuxdistrodisplay; 
					$_SESSION[$wizard_name]['osdistrodisplay'] = $osdistrodisplay; 
					
					/* The following variables need to be defined to prevent coding errors */
					}
				else {
					/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error<br />'); 
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$host_type = $_SESSION[$wizard_name]['host_type'];
					$linuxdistroselect = $_SESSION[$wizard_name]['linuxdistroselect'];
					$osdistroselect = $_SESSION[$wizard_name]['osdistroselect'];
					$userinput = $_SESSION[$wizard_name]['userinput'];
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE2HTML */
					}
				}
				
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
			$output = '						
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>
			
			<div style="width: 600px;"> <!-- This div sets the width -->
			
			<div class="sectionTitle">Host Summary</div>
			Selected host type: <b>'.$knownwizards[$host_type].'</b>
			<br />
			'.$linuxdistrodisplay.'
			'.$osdistrodisplay.'
			<br />
			'.$summaryAdd.'	
			'.$summarySkip.'	
			'.$summaryDuplicate.'	
			<br />
			<br />
			<b>Note:</b> In the next three screens there are options for services. Only host based options apply with this wizard, options for services are ignored.
			<br />
			<br />
			<p>
			Click Next if you are happy with the hosts that are going to be created.
			<br />
			<br />
			Click Back to make changes.
			<br />
			</p>
			</div> <!-- This is the end of the div for width -->
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE2HTML */
			break;

			
		/* Form validation for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
		case CONFIGWIZARD_MODE_VALIDATESTAGE2DATA:
			/* No validation necessary for this stage */
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE2DATA */
			break;

		
		case CONFIGWIZARD_MODE_GETSTAGE3HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE4HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 		
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE4HTML OR continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML */
			if (!$back) {
				/* Continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('Continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML <br />'); 
				
				/* grab array variables from CONFIGWIZARD_MODE_GETSTAGE2HTML */
				
				/* We will save these to the session variable array for later use */
				}
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />_SESSION[hostcreationtool]<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br />'); 
			
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
			$output = '						
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE3HTML */
			break;
			
			
		case CONFIGWIZARD_MODE_VALIDATESTAGE3DATA:
			/* No validation necessary for this stage */
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE3DATA */
			break;
		
	
		case CONFIGWIZARD_MODE_GETFINALSTAGEHTML:
			$host_type = $_SESSION[$wizard_name]['host_type'];
			$summaryAdd = $_SESSION[$wizard_name]['summaryAdd'];
			$knownwizards = knownwizards();
			$linuxdistrodisplay = $_SESSION[$wizard_name]['linuxdistrodisplay'];
			$osdistrodisplay = $_SESSION[$wizard_name]['osdistrodisplay'];
				
			//print_r('<br />new hosts<br />'); 
			//print_r($_SESSION[$wizard_name]['newhosts']); 
			//print_r('<br /><br />'); 
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETFINALSTAGEHTML */ 
			$output = '
			Selected host type: <b>'.$knownwizards[$host_type].'</b>
			<br />
			'.$linuxdistrodisplay.'
			'.$osdistrodisplay.'
			<br />
			'.$summaryAdd.'	
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETFINALSTAGEHTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETFINALSTAGEHTML */
			break;
		
		
		/* This stage commits the wizard data into objects definitions to be imported */
		case CONFIGWIZARD_MODE_GETOBJECTS:
			/* Get the session data to turn into object configs */
			$host_type = $_SESSION[$wizard_name]['host_type'];
			$totalhostobjects = $_SESSION[$wizard_name]['newhosts']['hostcount'];
			$knownwizards = knownwizards();
			$linuxdistroselect = $_SESSION[$wizard_name]['linuxdistroselect'];
			$osdistroselect = $_SESSION[$wizard_name]['osdistroselect'];
			
			/* Initialize objects array, this will contain the objects that we will add */
			$objs = array();
			
			//$iconlinux = hostcreationtool_configwizard_get_linuxserver_distro_icon($linuxdistroselect);
			//$iconos = hostcreationtool_configwizard_get_osdistro_icon($osdistroselect);
			
			switch ($host_type) {
				
				case 'dellopenmanage':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_dell_om_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'dellups':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_genericnetdevice_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'dell3.png',
							'vrml_image' 		=> 'dell3.png',
							'statusmap_image' 	=> 'dell3.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'dhcp':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_genericnetdevice_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'network_node.png',
							'statusmap_image' 	=> 'network_node.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'dnsquery':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_dnsquery_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'server.png',
							'statusmap_image' 	=> 'server.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'email-delivery':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_generic_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image'		=> 'email-delivery.png',
							'statusmap_image' 	=> 'email-delivery.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'esensors-websensor':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_websensor_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'em01.png',
							'statusmap_image' 	=> 'em01.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'exchange':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_exchange_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'exchange2010.png',
							'statusmap_image' 	=> 'exchange2010.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'ftpserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_ftpserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'ftpserver.png',
							'statusmap_image' 	=> 'ftpserver.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'genericnetdevice':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use'				=> 'xiwizard_genericnetdevice_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image'		=> 'network_node.png',
							'statusmap_image'	=> 'network_node.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'ldapserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_ldapserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'directory_services3.png',
							'statusmap_image' 	=> 'directory_services3.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'linux-server':
					$icon = hostcreationtool_configwizard_get_linuxserver_distro_icon($linuxdistroselect);
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> $icon,
							'statusmap_image' 	=> $icon,
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'linux_snmp':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxsnmp_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'snmppenguin.png',
							'statusmap_image' 	=> 'snmppenguin.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'macosx':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'osx.png',
							'statusmap_image' 	=> 'osx.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'mailserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mailserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mailserver.png',
							'statusmap_image' 	=> 'mailserver.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				

				case 'mssql_database':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mssqldatabase_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mssqldatabase.png',
							'statusmap_image' 	=> 'mssqldatabase.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				

				case 'mssql_query':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mssqlquery_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mssqlquery.png',
							'statusmap_image' 	=> 'mssqlquery.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'mssql_server':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mssqlserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mssqlserver.png',
							'statusmap_image' 	=> 'mssqlserver.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'mysqlquery':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mysqlquery_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mysql.png',
							'statusmap_image' 	=> 'mysql.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'mysqlserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_mysqlserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'mysql.png',
							'statusmap_image' 	=> 'mysql.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'nagiosxiserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_nagiosxiserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'nagiosxiserver.png',
							'statusmap_image' 	=> 'nagiosxiserver.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'nrpe':
					$icon = hostcreationtool_configwizard_get_osdistro_icon($osdistroselect);
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> $icon,
							'statusmap_image' 	=> $icon,
							'_xiwizard'			=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;

					
				case 'passivecheck':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_passive_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'passivecheck.png',
							'statusmap_image' 	=> 'passivecheck.png',
							//'stalking_options'	=> ($statestalking=='yes')?'o,u,d':'n',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'postgresdb':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_postgresdb_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'postgres.png',
							'statusmap_image' 	=> 'postgres.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'postgresquery':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_postgresquery_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'postgres.png',
							'statusmap_image' 	=> 'postgres.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'postgresserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_postgresserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'postgres.png',
							'statusmap_image' 	=> 'postgres.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'printer':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_printer_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'printer2.png',
							'statusmap_image' 	=> 'printer2.png',
							'_xiwizard' 		=> 'printer',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'radiusserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_radiusserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'globe4.png',
							'statusmap_image' 	=> 'globe4.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'snmp':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_genericnetdevice_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'snmp.png',
							'statusmap_image' 	=> 'snmp.png',
							'_xiwizard' 		=> 'snmp',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'solaris':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'solaris.png',
							'statusmap_image' 	=> 'solaris.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'ssh-expect':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_generic_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'ssh-expect.png',
							'statusmap_image' 	=> 'ssh-expect.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'sshproxy':
					$icon = hostcreationtool_configwizard_get_osdistro_icon($osdistroselect);
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_linuxserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> $icon,
							'statusmap_image'	=> $icon,
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
					
				
				case 'switch':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_switch_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'switch.png',
							'statusmap_image' 	=> 'switch.png',
							'_xiwizard' 		=> 'switch',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'tcpudpport':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_genericnetdevice_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'server2.png',
							'statusmap_image' 	=> 'server2.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'vmwareesxvspherevcenterserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_vmwareesxvspherevcenterserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'_xiwizard' 		=> 'vmwareesxvspherevcenterserver',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'vmware':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_generic_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'vmware.png',
							'statusmap_image'	=> 'vmware.png',
							'_xiwizard' 		=> 'vmware',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'watchguard':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_switch_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'watchguard.png',
							'statusmap_image' 	=> 'watchguard.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'website':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_website_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'www_server.png',
							'statusmap_image' 	=> 'www_server.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'websiteurl':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_website_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'www_server.png',
							'statusmap_image' 	=> 'www_server.png',
							'_xiwizard'	 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'webtransaction':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_webtransaction_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'www_server.png',
							'statusmap_image' 	=> 'www_server.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'windowsdesktop':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_windowsdesktop_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'windowsxp.png',
							'statusmap_image' 	=> 'windowsxp.png',
							'_xiwizard' 		=> 'windowsdesktop',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'windowseventlog':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_windowsserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'windowseventlog.png',
							'statusmap_image' 	=> 'windowseventlog.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'windowsserver':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_windowsserver_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'win_server.png',
							'statusmap_image' 	=> 'win_server.png',
							'_xiwizard' 		=> 'windowsserver',
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'windowssnmp':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_windowssnmp_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'win_server.png',
							'statusmap_image' 	=> 'win_server.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				case 'windowswmi':
					$newhostcounter = 0;
					for ($newhostcounter; $newhostcounter < $totalhostobjects; $newhostcounter++) {
						/* Adding the host to the $objs array */
						$objs[$newhostcounter] = array(
							'type' 				=> OBJECTTYPE_HOST,
							'use' 				=> 'xiwizard_windowswmi_host',
							'host_name' 		=> $_SESSION[$wizard_name]['newhosts']['hostname'][$newhostcounter],
							'address'			=> $_SESSION[$wizard_name]['newhosts']['address'][$newhostcounter],
							'icon_image' 		=> 'win_server.png',
							'statusmap_image' 	=> 'win_server.png',
							'_xiwizard' 		=> $wizard_name,
							);
						/* Determining if there is a description and adding the alias if there is */
						if (isset($_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter])) {
							$objs[$newhostcounter]['alias'] = $_SESSION[$wizard_name]['newhosts']['description'][$newhostcounter];
							}
						}
					break;
				
				
				} /* End of switch */

			/* The following three lines can be enabled for debugging purposes */
			//print_r('<br />Objects Array:<br />');
			//print_r($objs);
			//print_r('<br />');
			
			/* Return the object definitions to the wizard */
			$outargs[CONFIGWIZARD_NAGIOS_OBJECTS] = $objs;
			
			/* clear the session variables for this wizard run */
			unset ($_SESSION[$wizard_name]); 
			
			/* The next line ends CONFIGWIZARD_MODE_GETOBJECTS */
			break;
			
		default:
			break;			
		}
		
	return $output;
	}

function knownwizards() {
	/* Building an array of known wizards */
	$knownwizards['dellopenmanage'] = 'Dell OpenManage';
	$knownwizards['dellups'] = 'Dell UPS';
	$knownwizards['dhcp'] = 'DHCP';
	$knownwizards['dnsquery'] = 'DNS Query';
	$knownwizards['email-delivery'] = 'Email Delivery';
	$knownwizards['esensors-websensor'] = 'ESensors Websensor';
	$knownwizards['exchange'] = 'Exchange Server';
	$knownwizards['ftpserver'] = 'FTP Server';
	$knownwizards['genericnetdevice'] = 'Generic Network Device';
	$knownwizards['ldapserver'] = 'LDAP Server';
	$knownwizards['linux-server'] = 'Linux Server';
	$knownwizards['linux_snmp'] = 'Linux SNMP';
	$knownwizards['macosx'] = 'Mac OS/X';
	$knownwizards['mailserver'] = 'Mail Server';
	$knownwizards['mssql_database'] = 'MSSQL Database';
	$knownwizards['mssql_query'] = 'MSSQL Query';
	$knownwizards['mssql_server'] = 'MSSQL Server';
	$knownwizards['mysqlquery'] = 'MySQL Query';
	$knownwizards['mysqlserver'] = 'MySQL Server';
	$knownwizards['nagiosxiserver'] = 'Nagios XI Server';
	$knownwizards['nrpe'] = 'NRPE';
	//$knownwizards['passivecheck'] = 'Passive Check';
	$knownwizards['postgresdb'] = 'Postgres Database';
	$knownwizards['postgresquery'] = 'Postgres Query';
	$knownwizards['postgresserver'] = 'Postgres Server';
	$knownwizards['printer'] = 'Printer';
	$knownwizards['radiusserver'] = 'RADIUS Server';
	$knownwizards['switch'] = 'Network Switch / Router';
	$knownwizards['snmp'] = 'SNMP';
	$knownwizards['solaris'] = 'Solaris Server';
	$knownwizards['ssh-expect'] = 'SSH Login';
	$knownwizards['sshproxy'] = 'SSH Proxy';
	$knownwizards['tcpudpport'] = 'TCP/UDP Port';
	$knownwizards['vmwareesxvspherevcenterserver'] = 'VMware ESX / vSphere / vCenter Server';
	$knownwizards['vmware'] = 'VMware';
	$knownwizards['watchguard'] = 'WatchGuard';
	$knownwizards['website'] = 'Website';
	$knownwizards['websiteurl'] = 'Website URL';
	$knownwizards['webtransaction'] = 'Web Transaction';
	$knownwizards['windowsdesktop'] = 'Windows Desktop';
	$knownwizards['windowseventlog'] = 'Windows Event Log';
	$knownwizards['windowsserver'] = 'Windows Server';
	$knownwizards['windowswmi'] = 'Windows WMI';
	return $knownwizards;
	}
	
function knownicons() {
	/* Building an array of known wizards */
	$knownicons['dellopenmanage'] = 'dell.png';
	$knownicons['dellups'] = 'dell3.png';
	$knownicons['dhcp'] = 'dhcp.png';
	$knownicons['dnsquery'] = 'community2.png';
	$knownicons['email-delivery'] = 'email-delivery.png';
	$knownicons['esensors-websensor'] = 'em01.png';
	$knownicons['exchange'] = 'exchange2010.png';
	$knownicons['ftpserver'] = 'ftpserver.png';
	$knownicons['genericnetdevice'] = 'network_node.png';
	$knownicons['ldapserver'] = 'directory_services3.png';
	$knownicons['linux-server'] = 'linux-server.png';
	$knownicons['linux_snmp'] = 'snmppenguin.png';
	$knownicons['macosx'] = 'osx.png';
	$knownicons['mailserver'] = 'mailserver.png';
	$knownicons['mssql_database'] = 'mssqldatabase.png';
	$knownicons['mssql_query'] = 'mssqlquery.png';
	$knownicons['mssql_server'] = 'mssqlserver.png';
	$knownicons['mysqlquery'] = 'mysql.png';
	$knownicons['mysqlserver'] = 'mysql.png';
	$knownicons['nagiosxiserver'] = 'nagiosxiserver.png';
	$knownicons['nrpe'] = 'remote.png';
	//$knownicons['passivecheck'] = 'passivecheck.png';
	$knownicons['postgresdb'] = 'postgres.png';
	$knownicons['postgresquery'] = 'postgres.png';
	$knownicons['postgresserver'] = 'postgres.png';
	$knownicons['printer'] = 'printer2.png';
	$knownicons['radiusserver'] = 'globe4.png';
	$knownicons['switch'] = 'switch.png';
	$knownicons['snmp'] = 'snmp.png';
	$knownicons['solaris'] = 'solaris.png';
	$knownicons['ssh-expect'] = 'ssh-expect.png';
	$knownicons['sshproxy'] = 'ssh.png';
	$knownicons['tcpudpport'] = 'serverport.png';
	$knownicons['vmwareesxvspherevcenterserver'] = 'vmware3.png';
	$knownicons['vmware'] = 'vmware.png';
	$knownicons['watchguard'] = 'watchguard.png';
	$knownicons['website'] = 'www_server.png';
	$knownicons['websiteurl'] = 'www_server.png';
	$knownicons['webtransaction'] = 'whirl.png';
	$knownicons['windowsdesktop'] = 'windowsxp.png';
	$knownicons['windowseventlog'] = 'windowseventlog.png';
	$knownicons['windowsserver'] = 'win_server.png';
	$knownicons['windowswmi'] = 'win_server.png';
	return $knownicons;
	}

function alldistros($distro){
	$name = '';
	switch($distro){
		case 'AIX':
			$name = 'AIX';
			break;
		case 'CentOS':
			$name = 'CentOS';
			break;
		case 'Debian':
			$name = 'Debian';
			break;
		case 'Fedora':
			$name = 'Fedora Core';
			break;
		case 'FreeBSD':
			$name = 'FreeBSD';
			break;
		case 'HP-UX':
			$name = 'HP-UX';
			break;
		case 'Linux':
			$name = 'Linux Other';
			break;
		case 'NetBSD':
			$name = 'NetBSD';
			break;
		case 'OpenBSD':
			$name = 'OpenBSD';
			break;
		case 'Other':
			$name = 'Linux Other';
			break;
		case 'RHEL':
			$name = 'RedHat Enterprise Linux';
			break;
		case 'Solaris':
			$name = 'Solaris';
			break;
		case 'Ubuntu':
			$name = 'Ubuntu';
			break;
		case 'Windows':
			$name = 'Windows';
			break;
		}
	return $name;
	}

function hostcreationtool_configwizard_get_osdistro_icon($osdistro){
	$icon = 'linux.png';
	switch($osdistro){
		case 'Solaris':
			$icon = 'solaris.png';
			break;
		case 'AIX':
			$icon = 'aix.png';
			break;
		case 'HP-UX':
			$icon = 'hp-ux.png';
			break;
		case 'FreeBSD':
			$icon = 'freebsd2.png';
			break;
		case 'NetBSD':
			$icon = 'netbsd.png';
			break;
		case 'OpenBSD':
			$icon = 'openbsd.png';
			break;
		case 'Windows':
			$icon = 'windowsxp.png';
			break;
		case 'RHEL':
			$icon = 'redhat.png';
			break;
		case 'Fedora':
			$icon = 'fedora.png';
			break;
		case 'CentOS':
			$icon = 'centos.png';
			break;
		case 'Ubuntu':
			$icon = 'ubuntu.png';
			break;
		case 'Debian':
			$icon = 'debian.png';
			break;
		default:
			$icon = 'linux.png';
			break;
		}
	return $icon;
	}

function hostcreationtool_configwizard_get_linuxserver_distro_icon($linuxdistro){
	$icon = 'linux-server.png';
	switch($linuxdistro){
		case 'RHEL':
			$icon = 'redhat.png';
			break;
		case 'Fedora':
			$icon = 'fedora.png';
			break;
		case 'CentOS':
			$icon = 'centos.png';
			break;
		case 'Ubuntu':
			$icon = 'ubuntu.png';
			break;
		case 'Debian':
			$icon = 'debian.png';
			break;
		default:
			$icon = 'linux-server.png';
			break;
		}
	return $icon;
	}

?>